
/***************************************

 VN.C Engineering Table display routines

****************************************/


#include "vn.h"
#include <stdio.h>
#include <vgagl.h>

char *eng_names[] =
{
	"MTIS_FILE_NUMBER",
	"MTIS_RECORD_ID",
	"PHYSICAL_SEQUENCE_NUMBER",
	"LOGICAL_SEQUENCE_NUMBER",
	"FIRST_ERT_YEAR",
	"FIRST_ERT_DAY",
	"FIRST_ERT_MINUTE",
	"FIRST_ERT_MILLISECOND",
	"LAST_ERT_YEAR",
	"LAST_ERT_DAY",
	"LAST_ERT_MINUTE",
	"LAST_ERT_MILLISECOND",
	"FIRST_FDS16_COUNT",
	"FIRST_FDS60_COUNT",
	"FIRST_FDS_LINE_COUNT",
	"LAST_FDS16_COUNT",
	"LAST_FDS60_COUNT",
	"LAST_FDS_LINE_COUNT",
	"SCET_YEAR",
	"SCET_DAY",
	"SCET_MINUTE",
	"SCET_MILLISECOND",
	"MTIS_RECORDING_ID",
	"GCF_SYNC_MSB",
	"GCF_SYNC_LSB",
	"GCF_SOURCE_ID",
	"GCF_DESTINATION_ID",
	"GCF_BLOCK_ID",
	"GCF_GDD_ID",
	"GCF_UDT_ID",
	"GCF_DDT_ID",
	"GCF_SPACECRAFT_NUMBER",
	"GCF_TIME_ID",
	"GCF_DAY",
	"GCF_BLOCK_COUNT",
	"GCF_MILL_COUNT",
	"GCF_SERIAL_NUMBER",
	"GCF_CONFIGURATION",
	"GCF_ESC",
	"IRT_YEAR",
	"IRT_DAY",
	"IRT_MINUTE",
	"IRT_MILLISECOND",
	"FORMAT_ID",
	"IMAGE_FORMAT_ID",
	"FORMAT_SC_ID",
	"MIN_BSNR",
	"MAX_BSNR",
	"MIN_SSNR",
	"MAX_SSNR",
	"MIN_AGC",
	"MAX_AGC",
	"SYNC_ERROR_COUNT",
	"FDS_ERROR_COUNT",
	"SYNC_PARM_I",
	"SYNC_PARM_P",
	"SYNC_PARM_J",
	"SYNC_PARM_K",
	"SYNC_PARM_L",
	"SYNC_PARM_M",
	"SYNC_PARM_N",
	"SYNC_PARM_R",
	"LINES",
	"FULL_LINES",
	"PARTIAL_LINES",
	"UNREADABLE_RECORDS",
	"SEQUENCE_BREAKS",
	"SORT_PARAMETER",
	"IDR_FRAMES",
	"WBDL_FRAMES",
	"SDR_FRAMES",
	"MISSING_FRAMES",
	"IMAGE_ID",
	"TARGET_NAME",
	"INPUT_TYPE",
	"INPUT_SOURCE",
	"CAMERA_NUMBER",
	"SHUTTERED_PICTURE_FLAG",
	"READ_OUT_LINE_NUMBER",
	"READ_OUT_SEGMENT_NUMBER",
	"NA_CALIBRATION_FLAG",
	"WA_CALIBRATION_FLAG",
	"EXPOSURE_ID",
	"FILTER_ID",
	"FILTER_PARITY",
	"PICTURE_COUNT",
	"PRESENT_VALUE_A",
	"WORD_INDICATOR_A",
	"WORD_POINTER_A",
	"PRESENT_VALUE_B",
	"WORD_POINTER_B",
	"PRESENT_VALUE_C",
	"WORD_INDICATOR_C",
	"PRESENT_VALUE_D",
	"WORD_INDICATOR_D",
	"WORD_POINTER_D",
	"NA_ANALOG_SAMPLE",
	"WA_ANALOG_SAMPLE",
	"PIX_AVERAGE_STATUS",
	"PIX_AVERAGE",
	"WA_LSB_TRUNC_FLAG",
	"NA_LSB_TRUNC_FLAG",
	"SECONDARY_MEMORY_READOUT",
	"ISS_ENG"
};



void disp_engtable(engtable * engtab, int part, int disable_clipping)
{
	int y = 80, n;
	char buf[80];

	gl_setclippingwindow(0, 75, 223, 740);
	gl_clearscreen(0);

	if (disable_clipping)
		gl_setclippingwindow(0, 75, 1023, 740);
	
	switch (part) {
	case 1:
		sprintf(buf, "%s = %u", eng_names[0], engtab->MTIS_FILE_NUMBER);
		gl_write(0, y, buf);
		sprintf(buf, "%s = %u", eng_names[1], engtab->MTIS_RECORD_ID);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %u", eng_names[2], engtab->PHYSICAL_SEQUENCE_NUMBER);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %u", eng_names[3], engtab->LOGICAL_SEQUENCE_NUMBER);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %u", eng_names[4], engtab->FIRST_ERT.FIRST_ERT_YEAR);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %u", eng_names[5], engtab->FIRST_ERT.FIRST_ERT_DAY);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %u", eng_names[6], engtab->FIRST_ERT.FIRST_ERT_MINUTE);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %u", eng_names[7], engtab->FIRST_ERT.FIRST_ERT_MILLISECOND);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %u", eng_names[8], engtab->LAST_ERT.LAST_ERT_YEAR);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %u", eng_names[9], engtab->LAST_ERT.LAST_ERT_DAY);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %u", eng_names[10], engtab->LAST_ERT.LAST_ERT_MINUTE);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %u", eng_names[11], engtab->LAST_ERT.LAST_ERT_MILLISECOND);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %u", eng_names[12], engtab->FIRST_FDS16_COUNT);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %u", eng_names[13], engtab->FIRST_FDS60_COUNT);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %u", eng_names[14], engtab->FIRST_FDS_LINE_COUNT);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %u", eng_names[15], engtab->LAST_FDS16_COUNT);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %u", eng_names[16], engtab->LAST_FDS60_COUNT);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %u", eng_names[17], engtab->LAST_FDS_LINE_COUNT);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %u", eng_names[18], engtab->SCET.SCET_YEAR);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %u", eng_names[19], engtab->SCET.SCET_DAY);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %u", eng_names[20], engtab->SCET.SCET_MINUTE);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %u", eng_names[21], engtab->SCET.SCET_MILLISECOND);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %20s", eng_names[22], engtab->MTIS_RECORDING_ID);
		gl_write(0, y += 12, buf);

		for (n = 0; n < 2; n++) {
			sprintf(buf, "%s[%d] = %u", eng_names[23], n + 1, engtab->GCF_TABLE[n].SYNC_MSB);
			gl_write(0, y += 12, buf);
			sprintf(buf, "%s[%d] = %u", eng_names[24], n + 1, engtab->GCF_TABLE[n].SYNC_LSB);
			gl_write(0, y += 12, buf);
			sprintf(buf, "%s[%d] = %u", eng_names[25], n + 1, engtab->GCF_TABLE[n].SOURCE_ID);
			gl_write(0, y += 12, buf);
			sprintf(buf, "%s[%d] = %u", eng_names[26], n + 1, engtab->GCF_TABLE[n].DESTINATION_ID);
			gl_write(0, y += 12, buf);
			sprintf(buf, "%s[%d] = %u", eng_names[27], n + 1, engtab->GCF_TABLE[n].BLOCK_ID);
			gl_write(0, y += 12, buf);
			sprintf(buf, "%s[%d] = %u", eng_names[28], n + 1, engtab->GCF_TABLE[n].GDD_ID);
			gl_write(0, y += 12, buf);
			sprintf(buf, "%s[%d] = %u", eng_names[29], n + 1, engtab->GCF_TABLE[n].UDT_ID);
			gl_write(0, y += 12, buf);
			sprintf(buf, "%s[%d] = %u", eng_names[30], n + 1, engtab->GCF_TABLE[n].DDT_ID);
			gl_write(0, y += 12, buf);
			sprintf(buf, "%s[%d] = %u", eng_names[31], n + 1, engtab->GCF_TABLE[n].SPACECRAFT_NUMBER);
			gl_write(0, y += 12, buf);
			sprintf(buf, "%s[%d] = %lu", eng_names[32], n + 1, (long) (engtab->GCF_TABLE[n].TIME_ID_LSB +
				65536l * engtab->GCF_TABLE[n].TIME_ID_MSB));
			gl_write(0, y += 12, buf);
			sprintf(buf, "%s[%d] = %u", eng_names[33], n + 1, engtab->GCF_TABLE[n].DAY);
			gl_write(0, y += 12, buf);
			sprintf(buf, "%s[%d] = %u", eng_names[34], n + 1, engtab->GCF_TABLE[n].LSB_BLOCK_COUNT +
				256 * engtab->GCF_TABLE[n].MSB_BLOCK_COUNT);
			gl_write(0, y += 12, buf);
			sprintf(buf, "%s[%d] = %u", eng_names[35], n + 1, engtab->GCF_TABLE[n].MILL_COUNT);
			gl_write(0, y += 12, buf);
			sprintf(buf, "%s[%d] = %u", eng_names[36], n + 1, engtab->GCF_TABLE[n].SERIAL_NUMBER);
			gl_write(0, y += 12, buf);
			sprintf(buf, "%s[%d] = %u", eng_names[37], n + 1, engtab->GCF_TABLE[n].CONFIGURATION);
			gl_write(0, y += 12, buf);
			sprintf(buf, "%s[%d] = %u", eng_names[38], n + 1, engtab->GCF_TABLE[n].ESC);
			gl_write(0, y += 12, buf);
		}
		break;

	case 2:
		sprintf(buf, "%s = %u", eng_names[39], engtab->IRT.IRT_YEAR);
		gl_write(0, y, buf);
		sprintf(buf, "%s = %u", eng_names[40], engtab->IRT.IRT_DAY);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %u", eng_names[41], engtab->IRT.IRT_MINUTE);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %u", eng_names[42], engtab->IRT.IRT_MILLISECOND);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %u", eng_names[43], engtab->FORMAT.FORMAT_ID);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %u", eng_names[44], engtab->FORMAT.IMAGE_FORMAT_ID);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %u", eng_names[45], engtab->FORMAT.FORMAT_SC_ID);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %d", eng_names[46], engtab->MIN_BSNR);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %d", eng_names[47], engtab->MAX_BSNR);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %d", eng_names[48], engtab->MIN_SSNR);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %d", eng_names[49], engtab->MAX_SSNR);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %d", eng_names[50], engtab->MIN_AGC);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %d", eng_names[51], engtab->MAX_AGC);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %d", eng_names[52], engtab->SYNC_ERROR_COUNT);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %d", eng_names[53], engtab->FDS_ERROR_COUNT);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %u", eng_names[54], (unsigned) engtab->SYNC_PARAMETER_1.SYNC_PARM_I);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %u", eng_names[55], (unsigned) engtab->SYNC_PARAMETER_1.SYNC_PARM_P);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %u", eng_names[56], engtab->SYNC_PARAMETER_2.SYNC_PARM_J);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %u", eng_names[57], engtab->SYNC_PARAMETER_2.SYNC_PARM_K);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %u", eng_names[58], engtab->SYNC_PARAMETER_2.SYNC_PARM_L);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %u", eng_names[59], engtab->SYNC_PARAMETER_3.SYNC_PARM_M);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %u", eng_names[60], engtab->SYNC_PARAMETER_3.SYNC_PARM_N);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %u", eng_names[61], engtab->SYNC_PARAMETER_3.SYNC_PARM_R);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %u", eng_names[62], engtab->LINES);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %u", eng_names[63], engtab->FULL_LINES);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %u", eng_names[64], engtab->PARTIAL_LINES);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %u", eng_names[65], engtab->UNREADABLE_RECORDS);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %d", eng_names[66], engtab->SEQUENCE_BREAKS);
		gl_write(0, y += 12, buf);
		for (n = 0; n < 4; n++) {
			sprintf(buf, "%s[%d] = %d", eng_names[67], n, engtab->SORT_PARAMETER[n]);
			gl_write(0, y += 12, buf);
		}
		sprintf(buf, "%s = %d", eng_names[68], engtab->IDR_FRAMES);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %d", eng_names[69], engtab->WBDL_FRAMES);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %d", eng_names[70], engtab->SDR_FRAMES);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %d", eng_names[71], engtab->MISSING_FRAMES);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %10s", eng_names[72], engtab->IMAGE_ID);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %10s", eng_names[73], engtab->TARGET_NAME);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %d", eng_names[74], engtab->INPUT_TYPE);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %d", eng_names[75], engtab->INPUT_SOURCE);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %u", eng_names[76], engtab->SHUTTERED_PICTURE_ID.CAMERA_NUMBER);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %u", eng_names[77], engtab->SHUTTERED_PICTURE_ID.SHUTTERED_PICTURE_FLAG);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %u", eng_names[78], engtab->SCAN_MODE.READ_OUT_LINE_NUMBER);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %u", eng_names[79], engtab->SCAN_MODE.READ_OUT_SEGMENT_NUMBER);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %u", eng_names[80], engtab->CAMERA_MODE.NA_CALIBRATION_FLAG);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %u", eng_names[81], engtab->CAMERA_MODE.WA_CALIBRATION_FLAG);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %u", eng_names[82], engtab->CAMERA_MODE.EXPOSURE_ID);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %u", eng_names[83], engtab->CAMERA_MODE.FILTER_ID);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %u", eng_names[84], engtab->CAMERA_MODE.FILTER_PARITY);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %d", eng_names[85], engtab->PICTURE_COUNT);
		gl_write(0, y += 12, buf);
		break;
	case 3:
		sprintf(buf, "%s = %d", eng_names[86], engtab->PRESENT_VALUE_A);
		gl_write(0, y, buf);
		sprintf(buf, "%s = %d", eng_names[87], engtab->WORD_INDICATOR_A);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %d", eng_names[88], engtab->WORD_POINTER_A);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %d", eng_names[89], engtab->PRESENT_VALUE_B);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %d", eng_names[90], engtab->WORD_POINTER_B);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %d", eng_names[91], engtab->PRESENT_VALUE_C);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %d", eng_names[92], engtab->WORD_INDICATOR_C);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %d", eng_names[93], engtab->PRESENT_VALUE_D);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %d", eng_names[94], engtab->WORD_INDICATOR_D);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %d", eng_names[95], engtab->WORD_POINTER_D);
		gl_write(0, y += 12, buf);
		for (n = 0; n < 5; n++) {
			sprintf(buf, "%s[%d] = %d", eng_names[96], n + 1, engtab->ANALOG_SAMPLE_TABLE[n].NA_ANALOG_SAMPLE);
			gl_write(0, y += 12, buf);
			sprintf(buf, "%s[%d] = %d", eng_names[97], n + 1, engtab->ANALOG_SAMPLE_TABLE[n].WA_ANALOG_SAMPLE);
			gl_write(0, y += 12, buf);
		}
		sprintf(buf, "%s = %d", eng_names[98], engtab->PIX_STAT.PIX_AVERAGE_STATUS);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %d", eng_names[99], engtab->PIX_STAT.PIX_AVERAGE);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %d", eng_names[100], engtab->PIX_STAT.WA_LSB_TRUNC_FLAG);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %d", eng_names[101], engtab->PIX_STAT.NA_LSB_TRUNC_FLAG);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s = %d", eng_names[102], engtab->PIX_STAT.SECONDARY_MEMORY_READOUT);
		gl_write(0, y += 12, buf);
		for (n = 0; n < 10; n++) {
			sprintf(buf, "%s[%d] = %d", eng_names[103], n + 1, engtab->ISS_ENG[n]);
			gl_write(0, y += 12, buf);
		}
	}
}
