
/*********************************

 VN.C Line suffix display routines

**********************************/

#include "vn.h"
#include <stdio.h>
#include <vgagl.h>

char *sufx_names[] =
{
	"FDS_MOD16_NUMBER",
	"FDS_MOD60_NUMBER",
	"FDS_LINE_NUMBER",
	"MTIS_LINE_NUMBER",
	"MISSING_FRAMES",
	"RETAINED_FRAME_BITS[10]",
	"INPUT_TYPE",
	"INPUT_SOURCE",
	"FIRST_SAMPLE_NUMBER",
	"LAST_SAMPLE_NUMBER"
};


void dispsufx(line_suffix linsufx[], int linenum, int disable_clipping)
{
	int n, m, y;
	char buf[80], linebuf[2000];

	gl_setclippingwindow(223, 0, 1023, 767);
	gl_getbox(224, linenum, 800, 2, linebuf);
	gl_hline(223 + linsufx[linenum].FIRST_SAMPLE_NUMBER, linenum, 223 + linsufx[linenum].LAST_SAMPLE_NUMBER, 255);

	gl_setclippingwindow(0, 75, 222, 740);
	gl_clearscreen(0);
	
	if (disable_clipping)
		gl_setclippingwindow(0, 75, 1023, 740);

	for (n = linenum, y = 80; n < linenum + 2; n++) {
		sprintf(buf, "%s[%d] = %u", sufx_names[0], n + 1, linsufx[n].FDS_MOD16_NUMBER);
		gl_write(0, y += 24, buf);
		sprintf(buf, "%s[%d] = %u", sufx_names[1], n + 1, linsufx[n].FDS_MOD60_NUMBER);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s[%d] = %u", sufx_names[2], n + 1, linsufx[n].FDS_LINE_NUMBER);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s[%d] = %u", sufx_names[3], n + 1, linsufx[n].MTIS_LINE_NUMBER);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s[%d] = %u", sufx_names[4], n + 1, linsufx[n].MISSING_FRAMES);
		gl_write(0, y += 12, buf);
		for (m = 0; m < 10; m++) {
			sprintf(buf, "%s[%d][%d] = %u", sufx_names[5], n + 1, m + 1, linsufx[n].RETAINED_FRAME_BITS[m]);
			gl_write(0, y += 12, buf);
		}
		sprintf(buf, "%s[%d] = %u", sufx_names[6], n + 1, linsufx[n].INPUT_TYPE);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s[%d] = %u", sufx_names[7], n + 1, linsufx[n].INPUT_SOURCE);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s[%d] = %u", sufx_names[8], n + 1, linsufx[n].FIRST_SAMPLE_NUMBER);
		gl_write(0, y += 12, buf);
		sprintf(buf, "%s[%d] = %u", sufx_names[9], n + 1, linsufx[n].LAST_SAMPLE_NUMBER);
		gl_write(0, y += 12, buf);

	}
	gl_setclippingwindow(224, 0, 1023, 767);
	gl_putbox(224, linenum, 800, 2, linebuf);
}
